/* dib.h
*
*/

class CDib
{
public:
	CDib();
	~CDib();
	BOOL Create(int width, int height, int nColorBits);
	void Delete();
	BOOL IsValid();
	int GetInfoHeaderSize();
	BITMAPINFO *GetInfo();
	BYTE * GetBits();
	int GetWidth();
	int GetHeight();
	int GetBitsPerPixel();
	int GetLineWidth();
	int GetNumColors();
	RGBQUAD * GetColors();
	void SetPalette(HPALETTE hpal);
	HPALETTE CreatePalette();
	int Read(char * szFileName);
	int Write(char *szFileName);
	void Blit(HDC hdc, int x, int y);
	void Blit(HDC hdc, int x, int y, int width, int height);
private:
	void CalcBits();
	BYTE *lpDib;
	BYTE *pBits;
};

inline BOOL CDib::IsValid()
{
	return (lpDib? TRUE: FALSE);
}

inline BYTE *CDib::GetBits()
{
	return pBits;
}

inline BITMAPINFO *CDib::GetInfo()
{
	return (BITMAPINFO *) lpDib;
}

inline void CDib::Blit(HDC hdc, int x, int y)
{
	int cxDib = GetWidth();
	int cyDib = GetHeight();
	SetDIBitsToDevice (hdc, x, y, cxDib, cyDib,
		0, 0, 0, cyDib, GetBits(), GetInfo(), DIB_RGB_COLORS);
}

inline void CDib::Blit(HDC hdc, int x, int y, int width, int height)
{
	int cxDib = GetWidth();
	int cyDib = GetHeight();
	StretchDIBits (hdc, x, y, width, height,
		0, 0, cxDib, cyDib, GetBits(), GetInfo(),
		DIB_RGB_COLORS, SRCCOPY);
}

